﻿import es
import popuplib
import weaponlib
import cmdlib
import esamlib


#Unbegrenzt erweiterbar, einfach nur die STEAMIDs der Admins eintragen!
admins = ["STEAM_ID_LAN", "STEAM_ID_2", "STEAM_ID_3"]

#Der Befehl um den Spielern Waffen ect. zu geben:
befehl = "!weapons"


info = es.AddonInfo()
info.name = "WeaponGive"
info.version = "1.0.0"
info.author = "Brainsucker"
info.description = "Erlaubt Admins das Verteilen von Waffen"
info.url = "http://addons.eventscripts.com/addons/view/weapongive"

def getSteamidList():
	uidl = es.getUseridList()
	sidl = []
	for l in uidl:
		sidl.append(es.getplayersteamid(l))
	return sidl
	
def need_update():
	a = esamlib.getAddon("weapongive")
	try:
		newest_ver = a.currentversion
	except:
		pass
	else:
		if str(info["version"]) != str(newest_ver):
			return True
	return False


class PopupManager:
	def __init__(self, steamid):
		self.steamid = steamid
		self.chosenweapons = []
		self.chosenplayers = []
	def mp_select(self, userid, choice, popupid):
		if choice == 1:
			self.chosenweapons = []
			self.updateWeaponPopup()
			self.cw.send(userid)
			
		if choice == 2:
			self.chosenplayers = []
			self.updatePlayerPopup()
			self.cp.send(userid)
			
		if choice == 3:
			if len(self.chosenweapons) == 0:
				es.tell(userid, "#multi", "#defaultDu musst mindestens eine Waffe auswählen die du verteilen willst")
				self.updateMainPopup()
				popuplib.send("wg_mainpopup_%s" % self.steamid, userid)
				return
			if len(self.chosenplayers) == 0:
				es.tell(userid, "#multi", "#defaultDu musst mindestens einen Spieler auswählen dem du Waffen verteilen willst")
				self.updateMainPopup()
				popuplib.send("wg_mainpopup_%s" % self.steamid, userid)
				return
			
			for d in self.chosenplayers:
				if d in getSteamidList():
					for f in self.chosenweapons:
						es.server.queuecmd("es_xgive %s %s" % (str(es.getuserid(d)), f))
			es.tell(userid, "#multi", "#green[WeaponGive] #defaultEs wurden insgeamt #lightgreen%i Waffen #defaultan #lightgreen%i Spieler #defaultverteilt." % (len(self.chosenplayers)*len(self.chosenweapons), len(self.chosenplayers)))
				
	def cw_select(self, userid, choice, popupid):
		if choice in weaponlib.getWeaponNameList():
			self.changeWeaponState(choice)
		self.updateWeaponPopup()
		self.cw.send(userid)
		
	def cp_select(self, userid, choice, popupid):
		if choice in es.getUseridList():
			self.changePlayerState(es.getplayersteamid(choice), True)
		self.updatePlayerPopup()
		self.cp.send(userid)
				
	def changePlayerState(self, uid, is_steamid=False):
		#Das erlaubt uns auch direkt eine STEAMID an die Funktion weiter zu geben.
		if is_steamid:
			if not self.chosenplayers.count(uid):
				self.chosenplayers.append(uid)
				return
			if self.chosenplayers.count(uid):
				self.chosenplayers.remove(uid)
				return
		else:
			sid = es.getplayersteamid(uid)
			if not self.chosenplayers.count(sid):
				self.chosenpalayers.append(sid)
				return
			if self.chosenplayers.count(sid):
				self.chosenplayers.remove(sid)
				return
			
	def changeWeaponState(self, wname):
		if not self.chosenweapons.count(wname):
			self.chosenweapons.append(wname)
			return
		if self.chosenweapons.count(wname):
			self.chosenweapons.remove(wname)
			return
			
	def updateMainPopup(self):
		weaponlength = len(self.chosenweapons)
		playerlength = len(self.chosenplayers)
		if popuplib.exists("wg_mainpopup_%s" % self.steamid):
			popuplib.delete("wg_mainpopup_%s" % self.steamid)
		self.mp = popuplib.create("wg_mainpopup_%s" % self.steamid)
		self.mp.addline("%s Version %s" % (info["name"], info["version"]))
		self.mp.addline("--------------------")
		self.mp.addline("->1. Waffen auswählen" + (" (%i Waffe%s ausgewählt)" % (weaponlength, ("" if weaponlength == 1 else "n")) if weaponlength > 0 else ""))
		self.mp.addline("->2. Spieler auswählen" + ((" (%i Spieler ausgewählt)" % playerlength) if playerlength > 0 else ""))
		self.mp.addline("->3. Waffen jetzt verteilen")
		self.mp.addline("----------Geschrieben von %s----------" % info["author"])
		self.mp.addline("->9. Schließen")
		self.mp.menuselect = self.mp_select
			
	def updateWeaponPopup(self):
		if popuplib.exists("wg_chooseweapons_%s" % self.steamid):
			popuplib.delete("wg_chooseweapons_%s" % self.steamid)
		self.cw = popuplib.easymenu("wg_chooseweapons_%s" % self.steamid, None, self.cw_select)
		self.cw.settitle("Wähle die Waffen die du verteilen willst:")
		for w in weaponlib.getWeaponNameList():
			self.cw.addoption(w, ("* " if w in self.chosenweapons  else "") + w.replace("weapon_", "").capitalize())
			
	def updatePlayerPopup(self):
		if popuplib.exists("wg_chooseplayers_%s" % self.steamid):
			popuplib.delete("wg_chooseplayers_%s" % self.steamid)
		self.cp = popuplib.easymenu("wg_chooseplayers_%s" % self.steamid, None, self.cp_select)
		self.cp.settitle("Wähle die Spieler denen du Waffen verteilen willst:")
		for p in es.getUseridList():
			self.cp.addoption(p, ("* " if es.getplayersteamid(p) in self.chosenplayers else "") + es.getplayername(p))
			
	def getSteamid(self):
		return self.steamid

instancedict = {}
			
def cmdhandler(userid, args):
	steamid = es.getplayersteamid(userid)
	if steamid in admins:
		if not instancedict.has_key(steamid):
			instancedict[steamid] = PopupManager(steamid)
		if len(args) == 0:
			instancedict[steamid].updateMainPopup()
			popuplib.send("wg_mainpopup_%s" % steamid, userid)
		else:
			es.tell(userid, "#multi", "Diese Version ist nicht mit Unterbefehlen kompatibel!")

def load():
	cmdlib.registerSayCommand(befehl, cmdhandler, "Hauptbefehl mit Unterbefehlen zum Verteilen von Waffen")
	es.ServerVar(info["name"], str(info["version"]) + (" Veraltet" if need_update() else "")).makepublic()
	
def unload():
	for x in instancedict.keys():
		if popuplib.exists("wg_mainpopup_%s" % x):
			popuplib.delete("wg_mainpopup_%s" % x)
		if popuplib.exists("wg_chooseplayers_%s" % x):
			popuplib.delete("wg_chooseplayers_%s" % x)
		if popuplib.exists("wg_chooseweapons_%s" % x):
			popuplib.delete("wg_chooseweapons_%s" % x)
	cmdlib.unregisterSayCommand(befehl)